
from deal import cases, ensure, pre, raises, reason
from hypothesis import given


@raises(ZeroDivisionError)
@reason(ZeroDivisionError, lambda a, b: b == 0)
#@pre(lambda a, b: a >= 0 and b >= 0)
@ensure(lambda a, b, result: a == result * b + a % b)
def divide(a: int, b: int) -> int:
    return a // b


#def test_div_neg():
#    divide(3, -2)


@cases(divide, count=100)
def test_div(case):
    result = case()
    print(result)
